unit LogDialog;

interface

uses Windows, Messages, NForm;

type
  TLogDlg = class(TModelessDlg)
    Buf: string;
    procedure UpdateLog;
    procedure WMInitDialog(var Message: TWMInitDialog); message WM_INITDIALOG;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND;
  end;

implementation

uses MainForm; // XXX

const
  IDC_LOG = 100;

procedure TLogDlg.UpdateLog;
var
  n: Integer;
begin
  if IsWindow(Handle) then
    with Items[IDC_LOG] do
    begin
      SetText(Buf);
      n := SendMsg(EM_GETLINECOUNT, 0, 0);
      SendMsg(EM_LINESCROLL, 0, n);
      SendMsg(EM_SETSEL, Length(Buf), Length(Buf));
    end;
end;

procedure TLogDlg.WMInitDialog(var Message: TWMInitDialog);
begin
  SetText(AppName + ' Log'); // XXX
  SetFocus(Items[IDC_LOG].Handle);
  UpdateLog;
  Message.Result := 0;
end;

procedure TLogDlg.WMSize(var Message: TWMSize);
var
  w, h: Integer;
begin
  GetClientSize(w, h);
  Items[IDC_LOG].SetBounds(0, 0, w, h);
end;

procedure TLogDlg.WMCommand(var Message: TWMCommand);
begin
  with Message do
    case ItemID of
      IDOK, IDCANCEL:
        begin
          Result := 1;
          Close;
        end;
    end;
end;

end.
