program TestGauge;

uses Windows, NSys, NUtil, Gauge;

type
  TLogger = class(TObject)
    procedure Log(Sender: TObject; const Msg: string);
  end;

procedure TLogger.Log(Sender: TObject; const Msg: string);
begin
end;

var
  g: TGauges;
  l: TStrList;
  n: string;
  i: Integer;
  logger: TLogger;
  c: TCoord;
  msg: TMsg;
begin
  logger := TLogger.Create;
  g := TGauges.Create;
  g.Log := logger.Log;
  g['time.sec'];
  g['uptime.sec'];
  g['mem.phys.used'];
  g['disk.c.used'];
  g['disk.d.used'];
  g['cpu.load'];
  g['net.in.bytespersec'];
  g['udp.test'];
  g['hdtemp.hd0'];
  g.Update;

  l := TStrList.Create;
  while g.EachSymbols(n) do
    l.Add(n);
  l.Sort(StrColl);

  SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c);
  for i := 1 to 100 do
    Write(StringOfChar(' ', 80));

  while True do
  begin
    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c);
    for i := 0 to l.Count-1 do
       Writeln(l[i] + '=' + g[l[i]] + '         ');

    if PeekMessage(msg, 0, 0, 0, PM_REMOVE) then
      DispatchMessage(msg);
    Sleep(1000);
    g.Update;
  end;
  l.Free;
  g.Free;
end.
